#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#define M_SIZE (1*1024*1024)


int
main (int argc, char **argv)
{
  unsigned long maxpage;
  int *base1, *base2, *ptr1, *ptr2;
  unsigned int iter = 1;
  time_t clock;


  _malloc_options = "AJ";

  maxpage = strtol (argv[1], (char **) NULL, 10) * M_SIZE;
  fprintf (stderr, "Allocing %ld Bytes\n", maxpage);
  base1 = (int *) (malloc (maxpage / 2));
  base2 = (int *) (malloc (maxpage / 2));

  if (base1 == NULL)
    {
      fprintf (stderr, "Jammer 1\n");
      exit (1);
    }
  if (base2 == NULL)
    {
      fprintf (stderr, "Jammer 1\n");
      exit (1);
    }

  while (0 == 0)
    {
      unsigned int i;

      fprintf (stderr, "Starting loop <%d>\n  filling reference base ...", iter);
      clock = time(NULL);
      fprintf (stderr, "%s ", ctime(&clock));
      fflush (stderr);

      ptr1 = base1;
      for (i = 0; i < maxpage / 2 / sizeof (int); i++)
        {
          *(ptr1++) += i;
        }
      fprintf (stderr, " done\n  filling control base ...");
      clock = time(NULL);
      fprintf (stderr, "%s ", ctime(&clock));
      fflush (stderr);

      ptr2 = base2;
      for (i = 0; i < maxpage / 2 / sizeof (int); i++)
        {
          *(ptr2++) += i;
        }
      fprintf (stderr, " done\n  starting comparison ...");
      clock = time(NULL);
      fprintf (stderr, "%s ", ctime(&clock));
      fflush (stderr);

      ptr1 = base1;
      ptr2 = base2;
      for (i = 0; i < maxpage / 2 / sizeof (int); i++)
        {
          if (*ptr1 != *ptr2)
            {
              fprintf (stderr, "\n    index <%d> differ : <%d> <%d>", iter,
                       *ptr1, *ptr2);
              fflush (stderr);
            }
          ptr1++;
          ptr2++;
        }
      fprintf (stderr, " done (%d integer comparisons)\n\n",i);
      clock = time(NULL);
      fprintf (stderr, "%s ", ctime(&clock));
      iter++;
    }
  exit (0);                     // never reached
}

